scalar phi_y=1.5
scalar phi_pi=1.5
scalar isigma=1/2

scalar tau=0.07
scalar phi_y_p=phi_y+@nrnd*tau
scalar phi_pi_p=phi_pi+@nrnd*tau
scalar isigma_p=isigma+@nrnd*tau

scalar phi_y=phi_y_p
scalar phi_pi=phi_pi_p
scalar sigma=1/isigma_p

exec C:\DSGE\solve_nk.prg
exec C:\DSGE\kalman_nk.prg
scalar ll_p=ll
scalar ac=0
scalar ac_d=0

!nrep=400000
!burnin=!nrep/2
vector(!nrep-!burnin) s_phi_y
vector(!nrep-!burnin) s_phi_pi
vector(!nrep-!burnin) s_sigma

for !i=1 to !nrep
   scalar phi_y=phi_y_p+@nrnd*tau
   scalar phi_pi=phi_pi_p+@nrnd*tau
   scalar isigma=isigma_p+@nrnd*tau   
   scalar sigma=1/isigma
  
   if phi_pi<=1 then
     phi_pi=phi_pi_p
     ac_d=ac_d+1
   else
   endif
 
   exec C:\DSGE\solve_nk.prg
   exec C:\DSGE\kalman_nk.prg
   scalar d1=@exp(ll)*@dnorm((phi_y-phi_y_p)/tau)*@dnorm((phi_y-1.5)/0.1)*@dnorm((isigma-isigma_p)/tau)*(@dgamma(isigma,0.1,0.1))*@dnorm((phi_pi-phi_pi_p)/tau)*@dnorm((phi_pi-1.5)/0.1)
   scalar d2=@exp(ll_p)*@dnorm((phi_y_p-phi_y)/tau)*@dnorm((phi_y_p-1.5)/0.1)*@dnorm((isigma_p-isigma)/tau)*(@dgamma(isigma_p,0.1,0.1))*@dnorm((phi_pi_p-phi_pi)/tau)*@dnorm((phi_pi_p-1.5)/0.1)


   if d2=0 then
      scalar pr=1
   else
      scalar pr=d1/d2
   endif
   vector(2) pp
   pp.fill 1, pr
   

   
    if @runif(0,1)<@min(pp) then
     scalar phi_y=phi_y
    scalar phi_pi=phi_pi
     scalar isigma=isigma
     scalar ac=ac+1
   else
     scalar phi_y=phi_y_p
     scalar phi_pi=phi_pi_p
     scalar isigma=isigma_p
   endif
  

   if !i>!burnin then
         s_phi_y(!i-!burnin)=phi_y
         s_phi_pi(!i-!burnin)=phi_pi
         s_sigma(!i-!burnin)=1/isigma
    else
    endif
   scalar phi_y_p=phi_y
   scalar phi_pi_p=phi_pi
   scalar isigma_p=isigma

   scalar ll_p=ll
next
