'workfile u 100

scalar beta=0.995
scalar kappa=(1-0.75)*(1-0.995*0.75)/0.75
'scalar phi_y=1.5
'scalar phi_pi=1.5

matrix(2,2) A
matrix(2,2) B
matrix(2,1) E

A.fill 0,1,beta,1
B.fill -kappa, 1+phi_y,1,phi_pi
E.fill 0,sigma

matrix Bt=@inverse(A)*B
matrix Ct=@inverse(A)*E

scalar b11=Bt(1,1)
scalar b12=Bt(1,2)
scalar b21=Bt(2,1)
scalar b22=Bt(2,2)
scalar c1=Ct(1,1)
scalar c2=Ct(2,1)


scalar l1=((b11+b22)+((b11+b22)^2-4*b11*b22+4*b21*b12)^0.5)/2
scalar l2=((b11+b22)-((b11+b22)^2-4*b11*b22+4*b21*b12)^0.5)/2

matrix(2,2) l
l.fill l1,0,0,l2

scalar p11=((1+((l1-b11)/b12)^2)^(-1))^0.5
scalar p21=(l1-b11)/b12*p11

scalar p12=((1+((l2-b11)/b12)^2)^(-1))^0.5
scalar p22=(l2-b11)/b12*p12

matrix(2,2) P
P.fill p11,p21,p12,p22

matrix Cd=@inverse(P)*Ct


matrix Q=-P*@inverse(l)*Cd
scalar q1=q(1,1)
scalar q2=q(2,1)


