!n=@columns(A0)
!k=@columns(D0)

if @rank(A0)=!n then
  
  else
  string comm_solve_dsge1 = "The coefficient matrix A is not invertible.  This program cannot be applied to your model. " 
  show comm_solve_dsge1 
  stop
endif

if jump+state<>!n then
  string comm_solve_dsge2 = "Your model is inconsistent with number of variables. " 
  show comm_solve_dsge2 
  stop
  else
endif


A=@inverse(A0)*B0
CC=@inverse(A0)*C0*sigmam


exec C:\Users\ktame\Desktop\Jordan.prg

scalar unstable=0
scalar stable=0

for !i=1 to !n
     if @abs(eigen(!i))>=1 then 
        unstable=unstable+1
        stable=stable
     else
        unstable=unstable
        stable=stable+1
       endif
next

if unstable>jump then 
  string comm_solve_dsge3 = "Your model does not have solution. Please modify your model" 
  show comm_solve_dsge3 
  stop
  else
  if unstable<jump then
     string comm_solve_dsge4 = "Your model has multiple equibibria. Please modify your model" 
     show comm_solve_dsge4 
     stop
     else
  endif
endif


matrix P=@inverse(Q_sort)


if stable=0 then

  matrix (unstable, unstable) L2=@identity(unstable)
  for !i=1 to unstable
       L2(!i,!i)=L_sort(!i+stable,!i+stable)
  next

  matrix (unstable,unstable) P22
  for !i=1 to unstable
      for !j=1 to unstable
      P22(!i,!j)=P(stable+!i,stable+!j)
      next
  next

  
  matrix (unstable, stable+unstable) P2
  for !i=1 to unstable
      for !j=1 to stable+unstable
       P2(!i,!j)=P(!i+stable,!j)
      next
  next 

  vector w_vec=@inverse(@kronecker(@identity(exo),@identity(jump))-@kronecker(@transpose(D0),@inverse(l2)))*@vec(@inverse(l2)*P2*CC)

  matrix (unstable, exo) w
  for !j=1 to exo
      for !i=1 to unstable
       w(!i,!j)=w_vec(!i+(!j-1)*exo)
      next
  next



  matrix beta2=-@inverse(P22)*W
  
else
  matrix (stable, stable) L1=@identity(stable)
  for !i=1 to stable
      L1(!i,!i)=L_sort(!i,!i)
  next

  matrix (unstable, unstable) L2=@identity(unstable)
  for !i=1 to unstable
       L2(!i,!i)=L_sort(!i+stable,!i+stable)
  next


  matrix (stable,stable) P11
  for !i=1 to stable
      for !j=1 to stable
         P11(!i,!j)=P(!i,!j)
      next
  next

  matrix (stable,unstable) P12
  for !i=1 to stable
      for !j=1 to unstable
        P12(!i,!j)=P(!i,stable+!j)
      next
  next

  matrix (unstable,stable) P21
  for !i=1 to unstable
      for !j=1 to stable
         P21(!i,!j)=P(stable+!i,!j)
      next
  next

  matrix (unstable,unstable) P22
  for !i=1 to unstable
      for !j=1 to unstable
      P22(!i,!j)=P(stable+!i,stable+!j)
      next
  next

  matrix (stable, stable+unstable) P1
  for !i=1 to stable
      for !j=1 to stable+unstable
       P1(!i,!j)=P(!i,!j)
      next
  next

  matrix (unstable, stable+unstable) P2
  for !i=1 to unstable
      for !j=1 to stable+unstable
       P2(!i,!j)=P(!i+stable,!j)
      next
  next 

  vector w_vec=@inverse(@kronecker(@identity(exo),@identity(jump))-@kronecker(@transpose(D0),@inverse(l2)))*@vec(@inverse(l2)*P2*CC)

  matrix (unstable, exo) w
  for !j=1 to exo
      for !i=1 to unstable
       w(!i,!j)=w_vec(!i+(!j-1)*exo)
      next
  next

  matrix beta1=-@inverse(P22)*P21
  matrix beta2=-@inverse(P22)*W

  matrix alpha1=@inverse(P11-P12*@inverse(P22)*P21)*L1*(P11-P12*@inverse(P22)*P21)
  matrix alpha2=-@inverse(P11-P12*@inverse(P22)*P21)*(L1*P12*@inverse(P22)*W+P12*@inverse(P22)*W*D0-P1*CC)
endif
