'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'This program solves a DSGE model. Appling this program to your model, 
'you get a state space representation(in other words, a reduced form). 

'To apply the program, your model should be transformed as follows:

'A*[k(t+1)   ] =B*[k(t)]+C*ep(t)
'   [Ey(t+1)]       [y(t)]
'ep(t)=D*ep(t-1)+e(t)

'where k(t) denotes a state variables vector, y(t) a jump variables vector, 
'and ep(t) a structural shcoks vector.

'This program yields the following state space representation:
'k(t+1)=alpha1*k(t)+alpha2*ep(t) 
'y(t)    =beta1*k(t)+beta2*ep(t) 
'The Main outputs of this program are alpha 1, alpha 2, beta 1, and beta 2.
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/



'Procedure
'Step 1. Create coefficients matrices, A, B, C, and D.
'Step 2. Fill the number of jump, state, and exogenous variables in the following. 
scalar jump=
scalar state=
scalar exo=
'Step 3. Run this program(click "Run" botten of this program).





exec C:\Users\ktame\Desktop\solve_dsge.prg
